/*	Prova del 12 Settembre 2006

	Data una coda con capacit pari ad "N" elementi scrivere una classe
	thread "Produttore" ed una classe thread "Consumatore" che rispettivamente
	devono eseguire un numero fissato di inserimenti ed estrazioni dalla coda.
	Le operazioni sulla coda (inserimento e prelievo) devono avvenire sempre
	una alla volta e se, ovviamente, l'operazione  possibile. Inoltre due operazioni
	di inserimento consecutive sulla coda non possono essere effettuate dallo stesso
	thread "Produttore". Questo vincolo non vale per i thread "Consumatore".

	Scrivere un programma che crei un oggetto di tipo "Coda" inizialmente vuoto,
	tre oggetti di tipo "Produttore" e due oggetti di tipo "Consumatore",
	ciascuno dei quali dovr effettuare un certo numero di inserimenti ed estrazioni.

	Codice: Enrico Saviano http://enrico.saviano.org
*/

public class A_060912
{
 public static void main(String args[]) {
	 Coda coda1=new Coda("Coda1",100); // Creazione oggetto di tipo Coda

	 Semaforo mutex=new Semaforo(1); // Creazione semaforo mutex
	 Semaforo vuoti=new Semaforo(100); // Creazione semaforo vuoti
	 Semaforo pieni=new Semaforo(0); // Creazione semaforo pieni

	 // Creo 3 oggetti di tipo Produttore
	 Produttore prod1=new Produttore("Prod1",mutex,vuoti,pieni,10,coda1,1); prod1.start();
	 Produttore prod2=new Produttore("Prod2",mutex,vuoti,pieni,10,coda1,2); prod2.start();
	 Produttore prod3=new Produttore("Prod3",mutex,vuoti,pieni,10,coda1,3); prod3.start();

	 // Creo 2 oggetti di tipo Consumatore
	 Consumatore cons1=new Consumatore("Cons1",mutex,vuoti,pieni,10,coda1); cons1.start();
	 Consumatore cons2=new Consumatore("Cons2",mutex,vuoti,pieni,10,coda1); cons2.start();
 }
}


class Coda {
	String nomecoda;
 int size,lastprod;

 public Coda(String n,int s)
 {
  nomecoda=n;
  size=s;
  lastprod=0; // Indice dell'ultimo Produttore
 }

 public void consuma()
 {
  System.out.println("Consumo elemento della coda");
 }

 public int produci(int prodid)
 {

  if(lastprod==prodid) // Verifico se l'ultimo inserimento lo ha fatto lo stesso produttore
  {
   System.out.println("Lo stesso produttore non puo' effettuare 2 inserimenti consecutivi");
   return(-1);
  }

  System.out.println("Inserisco elemento nella coda");

  lastprod=prodid;

  return(1);

 }

}


class Produttore extends Thread
{
 Semaforo mutex,vuoti,pieni; // Gli passo i semafori
 int ntimes=0; // Numero di esecuzioni
 int temp,prodid; // prodid  l'identificativo del produttore
 Coda coda; // Gli passo la coda

 public Produttore(String n,Semaforo m,Semaforo v,Semaforo p,int nt,Coda c,int pid)
 {
  super(n);
  mutex=m;
  vuoti=v;
  pieni=p;
  ntimes=nt;
  coda=c;
  prodid=pid; // Assegno l'id del produttore
  temp=0;
 }

 public void run()
 {

  for (int i=0;i<ntimes;i++)
  {
   vuoti.down();
   mutex.down();
   System.out.println("Sono il Produttore " + getName());
   temp=coda.produci(prodid);  // Inserisco l'elemento nella coda passando l'id del produttore
   mutex.up();

   if(temp==-1) // Se il metodo "produci" ritorna "-1" nella coda non  stato inserito nulla
   {
	vuoti.up(); // Incremento di nuovo il semaforo dei vuoti
   }

   else

   if(temp==1) // Se il metodo "produci" ritorna "1" nella coda  stato inserito un elemento
   {
    pieni.up(); // Incremento il semaforo dei pieni
   }

  }

 }

}


class Consumatore extends Thread
{
 Semaforo mutex,vuoti,pieni;
 int ntimes=0;
 Coda coda;

 public Consumatore(String n,Semaforo m,Semaforo v,Semaforo p,int nt,Coda c)
 {
  super(n);
  mutex=m;
  vuoti=v;
  pieni=p;
  ntimes=nt;
  coda=c;
 }

 public void run()
 {

  for(int i=0;i<ntimes;i++)
  {
   vuoti.up();
   mutex.down();
   System.out.println("Sono il Consumatore " + getName());
   coda.consuma(); // Consumo l'elemento nella coda
   mutex.up();
   pieni.down();
  }

 }

}

