/*	Prova 2 Novembre 2006

	Realizzare una classe thread "Paziente" che deve effettuare una visita
	odontoiatrica presso uno studio associato di tre dentisti.
	I primi due lavorano nella stanza A ed il terzo nella stanza B.
	Il paziente, per effettuare la visita:
	- interroga una segretaria per sapere se deve mettersi in coda fuori
	dalla stanza A o fuori dalla stanza B;
	- entra nella stanza ed effettua la visita.
	La segretaria smista (operando in mutua esclusione) via via due clienti
	verso la stanza A ed uno verso la stanza B. La stanza A consente l'accesso
	fino a due pazienti contemporaneamente mentre l'accesso alla stanza B  in mutua esclusione.
	Infine, scrivere un programma main che avvii l'esecuzione di "n" thread "Paziente".

	Codice: Enrico Saviano http://enrico.saviano.org
*/

class A_061102 {
	public static void main(String args[]) {
		Semaforo A = new Semaforo(2);
		Semaforo B = new Semaforo(1);
		Segretaria pupa = new Segretaria();

		Paziente p1 = new Paziente("Paz1", pupa, A, B);
		Paziente p2 = new Paziente("Paz2", pupa, A, B);
		Paziente p3 = new Paziente("Paz3", pupa, A, B);
		Paziente p4 = new Paziente("Paz4", pupa, A, B);
		Paziente p5 = new Paziente("Paz5", pupa, A, B);
		Paziente p6 = new Paziente("Paz6", pupa, A, B);
		Paziente p7 = new Paziente("Paz7", pupa, A, B);
		Paziente p8 = new Paziente("Paz8", pupa, A, B);
		p1.start(); p2.start(); p3.start(); p7.start();
		p4.start(); p5.start(); p6.start(); p8.start();
	}
}

class Segretaria {
	int codice, stanzaA = 0, stanzaB = 1;
	static Semaforo bancadati = new Semaforo(1);

	public int accedi() {
		bancadati.down();
		if (stanzaB > stanzaA) { stanzaA++; codice = 1; }
		else { stanzaB++; codice = 2; }
		bancadati.up();
		return codice;
	}
	public void paga(int stanza) {
		bancadati.down();
		if(stanza == 1) stanzaA--;
		else stanzaB--;
		bancadati.up();
	}
}

class Paziente extends Thread {
	String nome;
	Segretaria pupa;
	int num_stanza, tempo;
	Semaforo A, B;
	static Semaforo cortesia = new Semaforo(1);

	public Paziente(String nome, Segretaria pupa, Semaforo A, Semaforo B) {
		this.nome = nome;
		this.pupa = pupa;
		this.A = A;
		this.B = B;
		this.tempo = (int) ((float)Math.random()*5000+1000);
	}
	public void run() {
		try { sleep(tempo); } catch (InterruptedException e) {}
		cortesia.down();
		num_stanza = pupa.accedi();
		cortesia.up();
		if (num_stanza == 1) {
			System.out.println(nome+" aspetta per farsi curare nella stanza A");
			A.down();
			System.out.println(nome+" si sta facendo curare nella stanza A...");
			try{ sleep(tempo); } catch (InterruptedException e) {}
			System.out.println(nome+" ha liberato la stanza A, arrivederci");
			cortesia.down();
			pupa.paga(1);
			cortesia.up();
			A.up();
		}
		else {
			System.out.println(nome+" aspetta per farsi curare nella stanza B");
			B.down();
			System.out.println(nome+" si sta facendo curare nella stanza B...");
			try{ sleep(tempo); } catch (InterruptedException e) {}
			System.out.println(nome+" ha liberato la stanza B, arrivederci");
			cortesia.down();
			pupa.paga(2);
			cortesia.up();
			B.up();
		}
	}
}